searchData={"items":[{"type":"task","title":"mix multicodec.gen","doc":"","ref":"Mix.Tasks.Multicodec.Gen.html"},{"type":"function","title":"Mix.Tasks.Multicodec.Gen.run/1","doc":"","ref":"Mix.Tasks.Multicodec.Gen.html#run/1"},{"type":"module","title":"Multiformats","doc":"Documentation for `Multiformats`.","ref":"Multiformats.html"},{"type":"function","title":"Multiformats.hello/0","doc":"Hello world.","ref":"Multiformats.html#hello/0"},{"type":"function","title":"Examples - Multiformats.hello/0","doc":"iex> Multiformats.hello()\n    :world","ref":"Multiformats.html#hello/0-examples"},{"type":"module","title":"Multiformats.CID","doc":"Handles encoding and decoding CIDs using the multiformats library.","ref":"Multiformats.CID.html"},{"type":"function","title":"Multiformats.CID.decode/1","doc":"Decodes CID binary string into a CID struct.\n\nIf the CID begins with the `identity` prefix (`0x00`), it is assumed to be a CIDv1 string with no multibase encoding.","ref":"Multiformats.CID.html#decode/1"},{"type":"function","title":"Multiformats.CID.encode/2","doc":"Encodes binary content into a CIDv1 binary string. You control the descriptors and algorithms via the `opts` Keyword list argument.\n\nBy default (i.e. when `opts` is not given), the following values are used by default:\n\n- `:content_type` is set to `\"raw\"`\n- `:hash_algorithm` is set to `\"sha2-256\"`\n- `:base` is set to `:base32`","ref":"Multiformats.CID.html#encode/2"},{"type":"function","title":"Multiformats.CID.encode_v0/1","doc":"Encodes binary content into a CIDv0 binary string. This assumes the type of the content is `dag-pb`, uses the `sha2-256` hashing algorithm, and is `base58btc` encoded (but without the `z` prefix).","ref":"Multiformats.CID.html#encode_v0/1"},{"type":"function","title":"Multiformats.CID.is_v0?/1","doc":"Only CIDv0 has an explicit check because all subsequent CID versions are self-describing and therefore you can just pop the version number off the binary string.","ref":"Multiformats.CID.html#is_v0?/1"},{"type":"type","title":"Multiformats.CID.t/0","doc":"","ref":"Multiformats.CID.html#t:t/0"},{"type":"module","title":"Multiformats.Multibase","doc":"Multibase is a protocol for disambiguating the \"base encoding\" used to express binary data in text formats, as specified by [multiformats](https://github.com/multiformats/multibase).\n\n*Note*: Not all \"official\" multibase encodings are implemented here. Only those marked as \"final\" are guaranteed to be present.","ref":"Multiformats.Multibase.html"},{"type":"function","title":"Multiformats.Multibase.decode/2","doc":"Attempts to decode a binary string.","ref":"Multiformats.Multibase.html#decode/2"},{"type":"function","title":"Multiformats.Multibase.decode!/2","doc":"Decodes a multibase-encoded string. This will not return information about the encoding used, just the decoded binary data.","ref":"Multiformats.Multibase.html#decode!/2"},{"type":"function","title":"Multiformats.Multibase.encode/2","doc":"Encodes binary data using a supported multibase encoding.","ref":"Multiformats.Multibase.html#encode/2"},{"type":"module","title":"Multiformats.Multibase.AnyBase","doc":"This module can be used to create custom \"any base\" encoding/decoding functions.\n\nThe module creates code similar to Elixir's own `Base` module, except each module is intended to encapsulate a single base rather than multiple ones.\n\nA custom alphabet must be provided, and that alphabet is used to generate encoding and decoding functions at compile time.\n\nBy default, the \"base\" of the module is determined by the number of characters in the provided alphabet, e.g. `Base58` has a base of 58 because there are 58 characters.\n\nAt this time, padding is not an available option when using this module.\n\n*Note*: This module is not intended to be able to recreate _any_ multibase codec. The specific logic assumed by the generated code to encode and decode the data might not be applicable to all codecs. Ensure you thoroughly test any custom multibase codecs derived from this module.","ref":"Multiformats.Multibase.AnyBase.html"},{"type":"module","title":"Examples - Multiformats.Multibase.AnyBase","doc":"Let's say you wanted to have a base 58 \"codec\":\n\n    defmodule Base58 do\n      use Multiformats.Multibase.AnyBase\n        name: :base58btc,\n        alphabet: \"123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz\"\n    end\n\nThen you can invoke the custom base codec using `encode/1` and `decode/1`:\n\n    Base58.encode(\"it's multiformats!\")\n    # => \"5NgpeksG5ZXZxPmAGtXZq7a7r\"\n\n    Base58.decode(\"5NgpeksG5ZXZxPmAGtXZq7a7r\")\n    # => {:ok, \"it's multiformats!\"}\n\nAdditionally, there are overridable \"hook\" functions that allow custom modules to have more control over the encoding and decoding algorithms. These functions are executed _at runtime_, not during compilation.\n\n- `before_encode/1`\n- `after_encode/1`\n- `before_decode/1`\n- `after_decode/1`\n\nBecause the encoding and decoding algorithms assume that binary strings are the inputs and outputs, each hook function should expect a binary string input and return a binary string output.","ref":"Multiformats.Multibase.AnyBase.html#module-examples"},{"type":"module","title":"Multiformats.Multibase.Base16","doc":"Delegates to Elixir's `Base` module.\n\nThis module and its functions exist solely to provide a consistent interface for encoding and decoding data using the `Multibase` library.","ref":"Multiformats.Multibase.Base16.html"},{"type":"function","title":"Multiformats.Multibase.Base16.decode/2","doc":"See `Base.decode16/2`.","ref":"Multiformats.Multibase.Base16.html#decode/2"},{"type":"function","title":"Multiformats.Multibase.Base16.decode!/2","doc":"See `Base.decode16!/2`.","ref":"Multiformats.Multibase.Base16.html#decode!/2"},{"type":"function","title":"Multiformats.Multibase.Base16.encode/2","doc":"See `Base.encode16/2`.","ref":"Multiformats.Multibase.Base16.html#encode/2"},{"type":"module","title":"Multiformats.Multibase.Base32","doc":"Delegates to Elixir's `Base` module.\n\nThis module and its functions exist solely to provide a consistent interface for encoding and decoding data using the `Multibase` library.","ref":"Multiformats.Multibase.Base32.html"},{"type":"function","title":"Multiformats.Multibase.Base32.decode/2","doc":"See `Base.decode32/2`.","ref":"Multiformats.Multibase.Base32.html#decode/2"},{"type":"function","title":"Multiformats.Multibase.Base32.decode!/2","doc":"See `Base.decode32!/2`.","ref":"Multiformats.Multibase.Base32.html#decode!/2"},{"type":"function","title":"Multiformats.Multibase.Base32.encode/2","doc":"See `Base.encode32/2`.","ref":"Multiformats.Multibase.Base32.html#encode/2"},{"type":"module","title":"Multiformats.Multibase.Base32Hex","doc":"Delegates to Elixir's `Base` module.\n\nThis module and its functions exist solely to provide a consistent interface for encoding and decoding data using the `Multibase` library.","ref":"Multiformats.Multibase.Base32Hex.html"},{"type":"function","title":"Multiformats.Multibase.Base32Hex.decode/2","doc":"See `Base.hex_decode32/2`.","ref":"Multiformats.Multibase.Base32Hex.html#decode/2"},{"type":"function","title":"Multiformats.Multibase.Base32Hex.decode!/2","doc":"See `Base.hex_decode32!/2`.","ref":"Multiformats.Multibase.Base32Hex.html#decode!/2"},{"type":"function","title":"Multiformats.Multibase.Base32Hex.encode/2","doc":"See `Base.hex_encode32/2`.","ref":"Multiformats.Multibase.Base32Hex.html#encode/2"},{"type":"module","title":"Multiformats.Multibase.Base36","doc":"","ref":"Multiformats.Multibase.Base36.html"},{"type":"function","title":"Multiformats.Multibase.Base36.after_decode/1","doc":"","ref":"Multiformats.Multibase.Base36.html#after_decode/1"},{"type":"function","title":"Multiformats.Multibase.Base36.after_encode/1","doc":"","ref":"Multiformats.Multibase.Base36.html#after_encode/1"},{"type":"function","title":"Multiformats.Multibase.Base36.before_decode/1","doc":"","ref":"Multiformats.Multibase.Base36.html#before_decode/1"},{"type":"function","title":"Multiformats.Multibase.Base36.before_encode/1","doc":"","ref":"Multiformats.Multibase.Base36.html#before_encode/1"},{"type":"function","title":"Multiformats.Multibase.Base36.decode/2","doc":"","ref":"Multiformats.Multibase.Base36.html#decode/2"},{"type":"function","title":"Multiformats.Multibase.Base36.decode!/2","doc":"","ref":"Multiformats.Multibase.Base36.html#decode!/2"},{"type":"function","title":"Multiformats.Multibase.Base36.encode/2","doc":"","ref":"Multiformats.Multibase.Base36.html#encode/2"},{"type":"module","title":"Multiformats.Multibase.Base58","doc":"","ref":"Multiformats.Multibase.Base58.html"},{"type":"function","title":"Multiformats.Multibase.Base58.after_decode/1","doc":"","ref":"Multiformats.Multibase.Base58.html#after_decode/1"},{"type":"function","title":"Multiformats.Multibase.Base58.after_encode/1","doc":"","ref":"Multiformats.Multibase.Base58.html#after_encode/1"},{"type":"function","title":"Multiformats.Multibase.Base58.before_decode/1","doc":"","ref":"Multiformats.Multibase.Base58.html#before_decode/1"},{"type":"function","title":"Multiformats.Multibase.Base58.before_encode/1","doc":"","ref":"Multiformats.Multibase.Base58.html#before_encode/1"},{"type":"function","title":"Multiformats.Multibase.Base58.decode/2","doc":"","ref":"Multiformats.Multibase.Base58.html#decode/2"},{"type":"function","title":"Multiformats.Multibase.Base58.decode!/2","doc":"","ref":"Multiformats.Multibase.Base58.html#decode!/2"},{"type":"function","title":"Multiformats.Multibase.Base58.encode/2","doc":"","ref":"Multiformats.Multibase.Base58.html#encode/2"},{"type":"module","title":"Multiformats.Multibase.Base58Flickr","doc":"","ref":"Multiformats.Multibase.Base58Flickr.html"},{"type":"function","title":"Multiformats.Multibase.Base58Flickr.after_decode/1","doc":"","ref":"Multiformats.Multibase.Base58Flickr.html#after_decode/1"},{"type":"function","title":"Multiformats.Multibase.Base58Flickr.after_encode/1","doc":"","ref":"Multiformats.Multibase.Base58Flickr.html#after_encode/1"},{"type":"function","title":"Multiformats.Multibase.Base58Flickr.before_decode/1","doc":"","ref":"Multiformats.Multibase.Base58Flickr.html#before_decode/1"},{"type":"function","title":"Multiformats.Multibase.Base58Flickr.before_encode/1","doc":"","ref":"Multiformats.Multibase.Base58Flickr.html#before_encode/1"},{"type":"function","title":"Multiformats.Multibase.Base58Flickr.decode/2","doc":"","ref":"Multiformats.Multibase.Base58Flickr.html#decode/2"},{"type":"function","title":"Multiformats.Multibase.Base58Flickr.decode!/2","doc":"","ref":"Multiformats.Multibase.Base58Flickr.html#decode!/2"},{"type":"function","title":"Multiformats.Multibase.Base58Flickr.encode/2","doc":"","ref":"Multiformats.Multibase.Base58Flickr.html#encode/2"},{"type":"module","title":"Multiformats.Multibase.Base58Ripple","doc":"","ref":"Multiformats.Multibase.Base58Ripple.html"},{"type":"function","title":"Multiformats.Multibase.Base58Ripple.after_decode/1","doc":"","ref":"Multiformats.Multibase.Base58Ripple.html#after_decode/1"},{"type":"function","title":"Multiformats.Multibase.Base58Ripple.after_encode/1","doc":"","ref":"Multiformats.Multibase.Base58Ripple.html#after_encode/1"},{"type":"function","title":"Multiformats.Multibase.Base58Ripple.before_decode/1","doc":"","ref":"Multiformats.Multibase.Base58Ripple.html#before_decode/1"},{"type":"function","title":"Multiformats.Multibase.Base58Ripple.before_encode/1","doc":"","ref":"Multiformats.Multibase.Base58Ripple.html#before_encode/1"},{"type":"function","title":"Multiformats.Multibase.Base58Ripple.decode/2","doc":"","ref":"Multiformats.Multibase.Base58Ripple.html#decode/2"},{"type":"function","title":"Multiformats.Multibase.Base58Ripple.decode!/2","doc":"","ref":"Multiformats.Multibase.Base58Ripple.html#decode!/2"},{"type":"function","title":"Multiformats.Multibase.Base58Ripple.encode/2","doc":"","ref":"Multiformats.Multibase.Base58Ripple.html#encode/2"},{"type":"module","title":"Multiformats.Multibase.Base64","doc":"Delegates to Elixir's `Base` module.\n\nThis module and its functions exist solely to provide a consistent interface for encoding and decoding data using the `Multibase` library.","ref":"Multiformats.Multibase.Base64.html"},{"type":"function","title":"Multiformats.Multibase.Base64.decode/2","doc":"See `Base.decode64/2`.","ref":"Multiformats.Multibase.Base64.html#decode/2"},{"type":"function","title":"Multiformats.Multibase.Base64.decode!/2","doc":"See `Base.decode64!/2`.","ref":"Multiformats.Multibase.Base64.html#decode!/2"},{"type":"function","title":"Multiformats.Multibase.Base64.encode/2","doc":"See `Base.encode64/2`.","ref":"Multiformats.Multibase.Base64.html#encode/2"},{"type":"module","title":"Multiformats.Multibase.Base64URL","doc":"Delegates to Elixir's `Base` module.\n\nThis module and its functions exist solely to provide a consistent interface for encoding and decoding data using the `Multibase` library.","ref":"Multiformats.Multibase.Base64URL.html"},{"type":"function","title":"Multiformats.Multibase.Base64URL.decode/2","doc":"See `Base.url_decode64/2`.","ref":"Multiformats.Multibase.Base64URL.html#decode/2"},{"type":"function","title":"Multiformats.Multibase.Base64URL.decode!/2","doc":"See `Base.url_decode64!/2`.","ref":"Multiformats.Multibase.Base64URL.html#decode!/2"},{"type":"function","title":"Multiformats.Multibase.Base64URL.encode/2","doc":"See `Base.url_encode64/2`.","ref":"Multiformats.Multibase.Base64URL.html#encode/2"},{"type":"module","title":"Multiformats.Multicodec","doc":"The primary module for fetching multicodec metadata.\n\nData *should be* generated from [this source table](https://github.com/multiformats/multicodec/blob/master/table.csv). However, the task to generate this source file accepts any appropriately-formatted CSV file, allowing for custom codecs to be used if desired.","ref":"Multiformats.Multicodec.html"},{"type":"function","title":"Multiformats.Multicodec.decode/1","doc":"Decodes binary data into the codec *name* and the embedded data.\n\nFor example, if the binary data is prefixed with `<<22>>` then the codec name returned will be `\"sha3-256\"`.\n\n    # On a successful decode, the second element is a tuple containing the codec name and associated binary data.\n    {:ok, {\"sha3-256\", data}} = decode(<<22, ...>>)\n\nPossible errors can occur from either an unknown codec, i.e. the prefix did not match any known codec, or the binary data was not properly varint-encoded.","ref":"Multiformats.Multicodec.html#decode/1"},{"type":"function","title":"Multiformats.Multicodec.encode/2","doc":"Encodes binary data using a codec. The codec can either be the name of the codec or the numeric representation of the codec. A numeric representation is either an integer, e.g. a codepoint or hex value, or a bitstring.","ref":"Multiformats.Multicodec.html#encode/2"},{"type":"function","title":"Multiformats.Multicodec.encode!/2","doc":"Similar to `encode/2`, but raises an error if the codec is not supported.","ref":"Multiformats.Multicodec.html#encode!/2"},{"type":"function","title":"Multiformats.Multicodec.get/1","doc":"Get a codec by either the integer/hex value or the human-readable name.","ref":"Multiformats.Multicodec.html#get/1"},{"type":"function","title":"Multiformats.Multicodec.parse_prefix/1","doc":"Parse the codec prefix from a binary string. Returns a tuple in the form of `{codec_metadata, data}`. Will return `nil` if the prefix does not match any known codec.","ref":"Multiformats.Multicodec.html#parse_prefix/1"},{"type":"behaviour","title":"Multiformats.Multicodec.Codec","doc":"A behaviour that defines common operations for \"codecs\" within the multiformats ecosystem.\n\nAt a high-level, a \"codec\" is simply an encapsulation of two functions: encoding and decoding. Both functions accept binary data and return binary data.\n\nIn order to support maximum flexibility, all functions accepts a second argument that can be anything. If you want to avoid having to manually write the 1-arity version of these functions by hand, you can `use` this module to have those functions generated for you. They will simply pass along an empty list (`[]`) to the 2-arity functions defined by this behaviour.\n\n*Note*: The `multihash` codecs are unique in that they are one-way cryptographic functions, meaning there is not way to reasonably \"decode\" the contents of a multihash. Therefore, it is encouraged to have `decode/2` and `decode!/2` raise errors when called from a `multihash` codec.","ref":"Multiformats.Multicodec.Codec.html"},{"type":"macro","title":"Multiformats.Multicodec.Codec.__using__/1","doc":"Adds the `@behaviour` attribute to the module and generates the 1-arity versions of the functions, which just call the 2-arity versions with an empty list for the second argument.\n\nYou may optionally pass in `multihash: true` in the options argument to have `decode/2` and `decode!/2` stubs generated in the resulting code, with each one simply raising a runtime error. This is `false` by default, i.e. it is assumed this is not a `multihash` codec.","ref":"Multiformats.Multicodec.Codec.html#__using__/1"},{"type":"callback","title":"Multiformats.Multicodec.Codec.decode/2","doc":"Decodes binary data, returning `{:ok, binary()}` if successful or `{:error, atom()}` if not.","ref":"Multiformats.Multicodec.Codec.html#c:decode/2"},{"type":"callback","title":"Multiformats.Multicodec.Codec.decode!/2","doc":"Decodes binary data, raising an error if the decoding fails.","ref":"Multiformats.Multicodec.Codec.html#c:decode!/2"},{"type":"callback","title":"Multiformats.Multicodec.Codec.encode/2","doc":"Encodes binary data with a set of optional arguments.","ref":"Multiformats.Multicodec.Codec.html#c:encode/2"},{"type":"module","title":"Multiformats.Multihash","doc":"Handles encoding and decoding multihash binary data, as specified by [multiformats](https://github.com/multiformats/multihash).","ref":"Multiformats.Multihash.html"},{"type":"function","title":"Multiformats.Multihash.decode/2","doc":"Decodes multihash binary data into a tuple of the hash type, digest size, and digest binary.\n\nCan pass an option to `:base` to encode the digest binary into a different format using multibase. Any base supported by `Multibase.encode/2` can be used here, otherwise you will receive an error.","ref":"Multiformats.Multihash.html#decode/2"},{"type":"function","title":"Multiformats.Multihash.encode/2","doc":"","ref":"Multiformats.Multihash.html#encode/2"},{"type":"function","title":"Multiformats.Multihash.encode!/2","doc":"","ref":"Multiformats.Multihash.html#encode!/2"},{"type":"module","title":"Multiformats.Multihash.Identity","doc":"The \"identity\" multihash algorithm is a no-op, meaning \"do not hash the binary data.\"","ref":"Multiformats.Multihash.Identity.html"},{"type":"function","title":"Multiformats.Multihash.Identity.decode/1","doc":"Decodes binary data using the default set of options.","ref":"Multiformats.Multihash.Identity.html#decode/1"},{"type":"function","title":"Multiformats.Multihash.Identity.decode/2","doc":"Not implemented.","ref":"Multiformats.Multihash.Identity.html#decode/2"},{"type":"function","title":"Multiformats.Multihash.Identity.decode!/1","doc":"Decodes binary data using the default set of options, raising an error if the decoding fails.","ref":"Multiformats.Multihash.Identity.html#decode!/1"},{"type":"function","title":"Multiformats.Multihash.Identity.decode!/2","doc":"Not implemented.","ref":"Multiformats.Multihash.Identity.html#decode!/2"},{"type":"function","title":"Multiformats.Multihash.Identity.encode/1","doc":"Encodes binary data using the default set of options.","ref":"Multiformats.Multihash.Identity.html#encode/1"},{"type":"function","title":"Multiformats.Multihash.Identity.encode/2","doc":"Returns the data unchanged.","ref":"Multiformats.Multihash.Identity.html#encode/2"},{"type":"module","title":"Multiformats.Multihash.SHA256Trunc254Padded","doc":"The \"sha2-256-trunc254-padded\" multihash algorithm is a variant of SHA-256 that replaces the most significant 2 bits of the last byte with zeroes.","ref":"Multiformats.Multihash.SHA256Trunc254Padded.html"},{"type":"function","title":"Multiformats.Multihash.SHA256Trunc254Padded.decode/1","doc":"Decodes binary data using the default set of options.","ref":"Multiformats.Multihash.SHA256Trunc254Padded.html#decode/1"},{"type":"function","title":"Multiformats.Multihash.SHA256Trunc254Padded.decode/2","doc":"Not implemented.","ref":"Multiformats.Multihash.SHA256Trunc254Padded.html#decode/2"},{"type":"function","title":"Multiformats.Multihash.SHA256Trunc254Padded.decode!/1","doc":"Decodes binary data using the default set of options, raising an error if the decoding fails.","ref":"Multiformats.Multihash.SHA256Trunc254Padded.html#decode!/1"},{"type":"function","title":"Multiformats.Multihash.SHA256Trunc254Padded.decode!/2","doc":"Not implemented.","ref":"Multiformats.Multihash.SHA256Trunc254Padded.html#decode!/2"},{"type":"function","title":"Multiformats.Multihash.SHA256Trunc254Padded.encode/1","doc":"Encodes binary data using the default set of options.","ref":"Multiformats.Multihash.SHA256Trunc254Padded.html#encode/1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}